

<form action="{{options.action}}" method="POST" enctype="multipart/form-data" class="dropzone {{options.dropzone_class}}">
    <input type="hidden" name="entity_id" value="{{entity_id}}">
    <input type="hidden" name="entity_type" value="{{entity_type}}">

    {% if token %}
    <input type="hidden" name="token" value="{{token}}">
    {% endif %}

    {% if options.singular %}
    <input type="hidden" name="singular" value="{{options.singular}}">
    {% endif %}

    {% if options.width %}
    <input type="hidden" name="width" value="{{options.width}}">
    {% endif %}

    {% if options.height %}
    <input type="hidden" name="height" value="{{options.height}}">
    {% endif %}
</form>
<script>

function fadeOut(el){
  el.style.opacity = 1;

  (function fade() {
    if ((el.style.opacity -= .1) < 0) {
      el.style.display = "none";
    } else {
      requestAnimationFrame(fade);
    }
  })();
};

function fadeIn(el, display){
  el.style.opacity = 0;
  el.style.display = display || "block";

  (function fade() {
    var val = parseFloat(el.style.opacity);
    if (!((val += .1) > 1)) {
      el.style.opacity = val;
      requestAnimationFrame(fade);
    }
  })();
};
    
function initializeDropzone(onSuccessHandler,onErrorHandler) {
    var formElement = document.querySelector('.{{options.dropzone_class}}');
    if (!formElement) {
        return;
    }

    var dropzone = new Dropzone(formElement, {
        paramName: '{{options.file_name}}',
        init: function() {
            this.on('success', onSuccessHandler);

            this.on('error', onErrorHandler);
        }
    });
}

function fetchFiles(){

    var append_elem = document.querySelector(".{{options.container_append_class}}");
   
    if(!append_elem){
        return;
    }
    return fetch("{{options.fetch_url}}",{
        method:"POST",
        headers: {
            //'Content-Type': 'application/json',
             'Content-Type': 'application/x-www-form-urlencoded',
             'X-Requested-With': 'XMLHttpRequest'
        },
        body:"entity_type={{entity_type|escape('js')}}&entity_id={{entity_id}}&token={{token}}"
    }).then(function(data){
        return data.json();
    }).then(function(response){
        if(response.success && response.html){
            append_elem.innerHTML = response.html;
        }else{
            append_elem.innerHTML = "<p>{{options.error_message}}</p>"
        }

        return response;
    });
}

function deleteFile(id){

   return fetch('{{options.delete_url}}'+id,{
        headers: {
            //'Content-Type': 'application/json',
             'Content-Type': 'application/x-www-form-urlencoded',
             'X-Requested-With': 'XMLHttpRequest'
        } 
    })
        .then(response=>response.json())
        .then(data=>{
            
            var messages_div = document.querySelector(".{{options.message_container_class}}");
            if(!messages_div){
                
                fetchFiles();
                return;
            }
            if(data.success){
              
                messages_div.innerHTML = "<div class='alert alert-success'>"+data.message+"</div>";
                
                setTimeout(function(){
                    fadeOut(messages_div);
                },5000);
                
                
            }else{
                messages_div.innerHTML = "<div class='alert alert-danger'>"+data.message+"</div>";

                setTimeout(function(){
                    fadeOut(messages_div);
                },5000);
            }
            fetchFiles();
        });
}


</script>